## ros-foxy-rosbag2-compression 0.3.11

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(rosbag2_compression)

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

# Windows supplies macros for min and max by default. We should only use min and max from stl
if(WIN32)
  add_definitions(-DNOMINMAX)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(rcpputils REQUIRED)
find_package(rcutils REQUIRED)
find_package(rosbag2_cpp)
find_package(rosbag2_storage REQUIRED)
find_package(zstd_vendor REQUIRED)
find_package(zstd REQUIRED)

add_library(${PROJECT_NAME}_zstd
  SHARED
  src/rosbag2_compression/zstd_compressor.cpp
  src/rosbag2_compression/zstd_decompressor.cpp)
target_include_directories(${PROJECT_NAME}_zstd
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)
ament_target_dependencies(${PROJECT_NAME}_zstd
  rcpputils
  rcutils
  rosbag2_storage
  zstd)
# Causes the visibility macros to use dllexport rather than dllimport.
# This is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME}_zstd
  PRIVATE
  ROSBAG2_COMPRESSION_BUILDING_DLL)

add_library(${PROJECT_NAME}
  SHARED
  src/rosbag2_compression/compression_factory.cpp
  src/rosbag2_compression/compression_options.cpp
  src/rosbag2_compression/sequential_compression_reader.cpp
  src/rosbag2_compression/sequential_compression_writer.cpp)
target_include_directories(${PROJECT_NAME}
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)
target_link_libraries(${PROJECT_NAME} ${PROJECT_NAME}_zstd)
ament_target_dependencies(${PROJECT_NAME}
  rcpputils
  rcutils
  rosbag2_cpp
  rosbag2_storage)
target_compile_definitions(${PROJECT_NAME} PRIVATE ROSBAG2_COMPRESSION_BUILDING_DLL)

install(
  DIRECTORY include/
  DESTINATION include)

install(
  TARGETS ${PROJECT_NAME} ${PROJECT_NAME}_zstd
  EXPORT export_${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME} ${PROJECT_NAME}_zstd)
ament_export_targets(export_${PROJECT_NAME})
# order matters here, first vendor, then zstd
ament_export_dependencies(rcpputils rcutils rosbag2_cpp rosbag2_storage zstd_vendor zstd)

if(BUILD_TESTING)
  find_package(ament_cmake_gmock REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  find_package(rclcpp REQUIRED)
  find_package(rosbag2_test_common REQUIRED)
  ament_lint_auto_find_test_dependencies()

  add_library(fake_compressor SHARED
    test/rosbag2_compression/fake_compressor.cpp)
  target_include_directories(fake_compressor PUBLIC include)
  ament_target_dependencies(fake_compressor rosbag2_storage)
  set_target_properties(fake_compressor
    PROPERTIES
    CXX_VISIBILITY_PRESET hidden
    VISIBILITY_INLINES_HIDDEN 1)
  target_compile_definitions(fake_compressor PRIVATE ROSBAG2_COMPRESSION_BUILDING_DLL)

  ament_add_gmock(test_compression_factory
    test/rosbag2_compression/test_compression_factory.cpp)
  target_link_libraries(test_compression_factory ${PROJECT_NAME})

  ament_add_gmock(test_compressor
    test/rosbag2_compression/test_compressor.cpp)
  target_link_libraries(test_compressor fake_compressor)
  ament_target_dependencies(test_compressor rcpputils)

  add_library(fake_decompressor SHARED
    test/rosbag2_compression/fake_decompressor.cpp)
  target_include_directories(fake_decompressor PUBLIC include)
  ament_target_dependencies(fake_decompressor rosbag2_storage rcpputils)
  set_target_properties(fake_decompressor
    PROPERTIES
    CXX_VISIBILITY_PRESET hidden
    VISIBILITY_INLINES_HIDDEN 1)
  target_compile_definitions(fake_decompressor PRIVATE ROSBAG2_COMPRESSION_BUILDING_DLL)

  ament_add_gmock(test_decompressor
    test/rosbag2_compression/test_decompressor.cpp)
  target_link_libraries(test_decompressor fake_decompressor)

  ament_add_gmock(test_zstd_compressor
    test/rosbag2_compression/test_zstd_compressor.cpp)
  target_include_directories(test_zstd_compressor PUBLIC include)
  target_link_libraries(test_zstd_compressor ${PROJECT_NAME}_zstd)
  ament_target_dependencies(test_zstd_compressor rclcpp rosbag2_test_common rosbag2_storage)

  ament_add_gmock(test_compression_options
    test/rosbag2_compression/test_compression_options.cpp)
  target_include_directories(test_compression_options PUBLIC include)
  target_link_libraries(test_compression_options ${PROJECT_NAME})

  ament_add_gmock(test_sequential_compression_reader
    test/rosbag2_compression/test_sequential_compression_reader.cpp)
  target_include_directories(test_sequential_compression_reader PUBLIC include)
  target_link_libraries(test_sequential_compression_reader ${PROJECT_NAME})
  ament_target_dependencies(test_sequential_compression_reader rosbag2_cpp)

  ament_add_gmock(test_sequential_compression_writer
    test/rosbag2_compression/test_sequential_compression_writer.cpp)
  target_include_directories(test_sequential_compression_writer PUBLIC include)
  target_link_libraries(test_sequential_compression_writer ${PROJECT_NAME})
  ament_target_dependencies(test_sequential_compression_writer rosbag2_cpp)
endif()

ament_package()

=== debian/changelog ===
ros-foxy-rosbag2-compression (0.3.11-1focal) focal; urgency=high



 -- Karsten Knese <karsten@openrobotics.org>  Sat, 27 May 2023 00:00:00 -0000

ros-foxy-rosbag2-compression (0.3.10-1focal) focal; urgency=high

  * Check & create database dirs before writing bags (#1133 <https://github.com/ros2/rosbag2/issues/1133>)
  * Contributors: Homalozoa X

 -- Karsten Knese <karsten@openrobotics.org>  Thu, 16 Mar 2023 00:00:00 -0000

ros-foxy-rosbag2-compression (0.3.9-1focal) focal; urgency=high



 -- Karsten Knese <karsten@openrobotics.org>  Thu, 03 Feb 2022 00:00:00 -0000

ros-foxy-rosbag2-compression (0.3.8-1focal) focal; urgency=high



 -- Karsten Knese <karsten@openrobotics.org>  Mon, 19 Jul 2021 00:00:00 -0000

ros-foxy-rosbag2-compression (0.3.7-1focal) focal; urgency=high



 -- Karsten Knese <karsten@openrobotics.org>  Mon, 15 Feb 2021 00:00:00 -0000

ros-foxy-rosbag2-compression (0.3.6-1focal) focal; urgency=high

  * Update maintainer list for Foxy (#551 <https://github.com/ros2/rosbag2/issues/551>)
  * Contributors: Michael Jeronimo

 -- Karsten Knese <karsten@openrobotics.org>  Tue, 05 Jan 2021 00:00:00 -0000

ros-foxy-rosbag2-compression (0.3.5-1focal) focal; urgency=high



 -- ROS Tooling Working Group <ros-tooling@googlegroups.com>  Mon, 31 Aug 2020 00:00:00 -0000

ros-foxy-rosbag2-compression (0.3.4-1focal) focal; urgency=high

  * Fix exception thrown given invalid arguments with compression enabled (#488 <https://github.com/ros2/rosbag2/issues/488>) (#489 <https://github.com/ros2/rosbag2/issues/489>)
  * Contributors: Devin Bonnie

 -- ROS Tooling Working Group <ros-tooling@googlegroups.com>  Wed, 05 Aug 2020 00:00:00 -0000

ros-foxy-rosbag2-compression (0.3.3-1focal) focal; urgency=high



 -- ROS Tooling Working Group <ros-tooling@googlegroups.com>  Tue, 23 Jun 2020 00:00:00 -0000

ros-foxy-rosbag2-compression (0.3.2-1focal) focal; urgency=high

  * Add user provided split size to error message (#430 <https://github.com/ros2/rosbag2/issues/430>)
  * Contributors: Anas Abou Allaban

 -- ROS Tooling Working Group <ros-tooling@googlegroups.com>  Wed, 03 Jun 2020 00:00:00 -0000

ros-foxy-rosbag2-compression (0.3.1-1focal) focal; urgency=high



 -- ROS Tooling Working Group <ros-tooling@googlegroups.com>  Mon, 01 Jun 2020 00:00:00 -0000

ros-foxy-rosbag2-compression (0.3.0-1focal) focal; urgency=high

  * Fix playback of compressed bagfiles (#417 <https://github.com/ros2/rosbag2/issues/417>)
  * Export targets (#403 <https://github.com/ros2/rosbag2/issues/403>)
  * Contributors: Emerson Knapp, Karsten Knese

 -- ROS Tooling Working Group <ros-tooling@googlegroups.com>  Tue, 26 May 2020 00:00:00 -0000

ros-foxy-rosbag2-compression (0.2.8-1focal) focal; urgency=high



 -- ROS Tooling Working Group <ros-tooling@googlegroups.com>  Mon, 18 May 2020 00:00:00 -0000

ros-foxy-rosbag2-compression (0.2.7-1focal) focal; urgency=high



 -- ROS Tooling Working Group <ros-tooling@googlegroups.com>  Tue, 12 May 2020 00:00:00 -0000

ros-foxy-rosbag2-compression (0.2.6-1focal) focal; urgency=high

  * Remove relative include paths in rosbag2_compression tests (#405 <https://github.com/ros2/rosbag2/issues/405>)
  * Contributors: Karsten Knese, Zachary Michaels

 -- ROS Tooling Working Group <ros-tooling@googlegroups.com>  Thu, 07 May 2020 00:00:00 -0000

ros-foxy-rosbag2-compression (0.2.5-1focal) focal; urgency=high

  * Don't fail build if lsan isn't available. (#397 <https://github.com/ros2/rosbag2/issues/397>)
  * Correctly set all test dependencies. (#392 <https://github.com/ros2/rosbag2/issues/392>)
  * Deduplicate code in SequentialCompressionReader. (#372 <https://github.com/ros2/rosbag2/issues/372>)
  * Add filter for reading selective topics. (#302 <https://github.com/ros2/rosbag2/issues/302>)
  * Add QoS profiles field to metadata struct and provide serialization utilities. (#330 <https://github.com/ros2/rosbag2/issues/330>)
  * Fix compression log logic. (#320 <https://github.com/ros2/rosbag2/issues/320>)
  * Fix throw in playback of split+compressed bagfiles. (#294 <https://github.com/ros2/rosbag2/issues/294>)
  * Refactor Compression Reader/Writers to use the CompressionFactory. (#315 <https://github.com/ros2/rosbag2/issues/315>)
  * Add compression factory implementation. (#313 <https://github.com/ros2/rosbag2/issues/313>)
  * Include stdexcept. (#314 <https://github.com/ros2/rosbag2/issues/314>)
  * Add compression factory stubs. (#311 <https://github.com/ros2/rosbag2/issues/311>)
  * Replace rcutils_get_file_size with rcpputils::fs::file_size. (#291 <https://github.com/ros2/rosbag2/issues/291>)
  * [compression] Enable compression through ros2bag cli. (#263 <https://github.com/ros2/rosbag2/issues/263>)
  * [compression] Close storage before compression. (#284 <https://github.com/ros2/rosbag2/issues/284>)
  * Improve logging in rosbag2_compression. (#287 <https://github.com/ros2/rosbag2/issues/287>)
  * Change validation functions to accept output type of ZSTD_getFrameContentSize. (#285 <https://github.com/ros2/rosbag2/issues/285>)
  * code style only: wrap after open parenthesis if not in one line. (#280 <https://github.com/ros2/rosbag2/issues/280>)
  * Add more assertions on rosbag2_compression. (#279 <https://github.com/ros2/rosbag2/issues/279>)
  * [compression] Add SequentialCompressionWriter. (#260 <https://github.com/ros2/rosbag2/issues/260>)
  * Add a SequentialCompressionReader. (#258 <https://github.com/ros2/rosbag2/issues/258>)
  * Move compression artifacts from rosbag2_cpp to rosbag2_compression. (#257 <https://github.com/ros2/rosbag2/issues/257>)
  * remove rosbag2 filesystem helper. (#249 <https://github.com/ros2/rosbag2/issues/249>)
  * [Compression - 8] Enable reader to read from compressed files/messages. (#246 <https://github.com/ros2/rosbag2/issues/246>)
  * [compression] Follow ROS2 style conventions better and throw eagerly. (#245 <https://github.com/ros2/rosbag2/issues/245>)


=== debian/control ===
Source: ros-foxy-rosbag2-compression
Section: misc
Priority: optional
Maintainer: Karsten Knese <karsten@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake, ros-foxy-ament-cmake-gmock <!nocheck>, ros-foxy-ament-lint-auto <!nocheck>, ros-foxy-ament-lint-common <!nocheck>, ros-foxy-rclcpp <!nocheck>, ros-foxy-rcpputils, ros-foxy-rcutils, ros-foxy-rosbag2-cpp, ros-foxy-rosbag2-storage, ros-foxy-rosbag2-test-common <!nocheck>, ros-foxy-zstd-vendor, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-rosbag2-compression
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-rcpputils, ros-foxy-rcutils, ros-foxy-rosbag2-cpp, ros-foxy-rosbag2-storage, ros-foxy-zstd-vendor, ros-foxy-ros-workspace
Description: Compression implementations for rosbag2 bags and messages.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-rosbag2-compression//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
